    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * --------------------------------
    028     * StandardPieToolTipGenerator.java
    029     * --------------------------------
    030     * (C) Copyright 2001-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   Richard Atkinson;
    034     *                   Andreas Schroeder;
    035     *
    036     * Changes
    037     * -------
    038     * 13-Dec-2001 : Version 1 (DG);
    039     * 16-Jan-2002 : Completed Javadocs (DG);
    040     * 29-Aug-2002 : Changed to format numbers using default locale (RA);
    041     * 26-Sep-2002 : Fixed errors reported by Checkstyle (DG);
    042     * 30-Oct-2002 : Changed PieToolTipGenerator interface (DG);
    043     * 21-Mar-2003 : Implemented Serializable (DG);
    044     * 13-Aug-2003 : Implemented Cloneable (DG);
    045     * 19-Aug-2003 : Renamed StandardPieToolTipGenerator -->
    046     *               StandardPieItemLabelGenerator (DG);
    047     * 10-Mar-2004 : Modified to use MessageFormat class (DG);
    048     * 31-Mar-2004 : Added javadocs for the MessageFormat usage (AS);
    049     * 15-Apr-2004 : Split PieItemLabelGenerator interface into
    050     *               PieSectionLabelGenerator and PieToolTipGenerator (DG);
    051     * 25-Nov-2004 : Moved some code into abstract super class (DG);
    052     * 29-Jul-2005 : Removed implementation of PieSectionLabelGenerator
    053     *               interface (DG);
    054     * 10-Jul-2007 : Added constructors with locale argument (DG);
    055     *
    056     */
    057
    058    package org.jfree.chart.labels;
    059
    060    import java.io.Serializable;
    061    import java.text.NumberFormat;
    062    import java.util.Locale;
    063
    064    import org.jfree.data.general.PieDataset;
    065    import org.jfree.util.PublicCloneable;
    066
    067    /**
    068     * A standard item label generator for plots that use data from a
    069     * {@link PieDataset}.
    070     * <p>
    071     * For the label format, use {0} where the pie section key should be inserted,
    072     * {1} for the absolute section value and {2} for the percent amount of the pie
    073     * section, e.g. <code>"{0} = {1} ({2})"</code> will display as
    074     * <code>apple = 120 (5%)</code>.
    075     */
    076    public class StandardPieToolTipGenerator extends AbstractPieItemLabelGenerator
    077            implements PieToolTipGenerator, Cloneable, PublicCloneable,
    078                Serializable {
    079
    080        /** For serialization. */
    081        private static final long serialVersionUID = 2995304200445733779L;
    082
    083        /** The default tooltip format. */
    084        public static final String DEFAULT_TOOLTIP_FORMAT = "{0}: ({1}, {2})";
    085
    086        /**
    087         * The default section label format.
    088         *
    089         * @deprecated As of 1.0.7, use {@link #DEFAULT_TOOLTIP_FORMAT} instead.
    090         */
    091        public static final String DEFAULT_SECTION_LABEL_FORMAT = "{0} = {1}";
    092
    093        /**
    094         * Creates an item label generator using default number formatters.
    095         */
    096        public StandardPieToolTipGenerator() {
    097            this(DEFAULT_TOOLTIP_FORMAT);
    098        }
    099
    100        /**
    101         * Creates a pie tool tip generator for the specified locale, using the
    102         * default format string.
    103         *
    104         * @param locale  the locale (<code>null</code> not permitted).
    105         *
    106         * @since 1.0.7
    107         */
    108        public StandardPieToolTipGenerator(Locale locale) {
    109            this(DEFAULT_TOOLTIP_FORMAT, locale);
    110        }
    111
    112        /**
    113         * Creates a pie tool tip generator for the default locale.
    114         *
    115         * @param labelFormat  the label format (<code>null</code> not permitted).
    116         */
    117        public StandardPieToolTipGenerator(String labelFormat) {
    118            this(labelFormat, Locale.getDefault());
    119        }
    120
    121        /**
    122         * Creates a pie tool tip generator for the specified locale.
    123         *
    124         * @param labelFormat  the label format (<code>null</code> not permitted).
    125         * @param locale  the locale (<code>null</code> not permitted).
    126         *
    127         * @since 1.0.7
    128         */
    129        public StandardPieToolTipGenerator(String labelFormat, Locale locale) {
    130            this(labelFormat, NumberFormat.getNumberInstance(locale),
    131                    NumberFormat.getPercentInstance(locale));
    132        }
    133
    134        /**
    135         * Creates an item label generator using the specified number formatters.
    136         *
    137         * @param labelFormat  the label format string (<code>null</code> not
    138         *                     permitted).
    139         * @param numberFormat  the format object for the values (<code>null</code>
    140         *                      not permitted).
    141         * @param percentFormat  the format object for the percentages
    142         *                       (<code>null</code> not permitted).
    143         */
    144        public StandardPieToolTipGenerator(String labelFormat,
    145                NumberFormat numberFormat, NumberFormat percentFormat) {
    146            super(labelFormat, numberFormat, percentFormat);
    147        }
    148
    149        /**
    150         * Generates a tool tip text item for one section in a pie chart.
    151         *
    152         * @param dataset  the dataset (<code>null</code> not permitted).
    153         * @param key  the section key (<code>null</code> not permitted).
    154         *
    155         * @return The tool tip text (possibly <code>null</code>).
    156         */
    157        public String generateToolTip(PieDataset dataset, Comparable key) {
    158            return generateSectionLabel(dataset, key);
    159        }
    160
    161        /**
    162         * Returns an independent copy of the generator.
    163         *
    164         * @return A clone.
    165         *
    166         * @throws CloneNotSupportedException  should not happen.
    167         */
    168        public Object clone() throws CloneNotSupportedException {
    169            return super.clone();
    170        }
    171
    172    }